<?php
/*
Plugin Name: Twitter Tools - Nice Links
Plugin URI: http://www.hyperborea.org/ 
Description: Follow links and convert from plain URLs to friendly-looking links with actual titles when building Twitter Tools digests.
Version: 0.9
Author: Kelson Vibber
Author URI: http://www.hyperborea.org/journal/nicelinks/
*/

// NOTE: Requires PHP 5 in order to pass a reference to foreach and curl in order to retrieve titles.

// ini_set('display_errors', '1'); ini_set('error_reporting', E_ALL);

function ktv_aktt_nicelinks($tweets_to_post) {
	foreach ($tweets_to_post as &$tweet) {
		preg_match_all('/[^>"]?(http:\/\/[^\s]+)/', $tweet->tw_text, $matches, PREG_PATTERN_ORDER);
		foreach ($matches[1] as $link) {
			$getlink = ktv_aktt_nicelinks_replace($link);
			if ($getlink != "")
			$tweet->tw_text = preg_replace('@(^|[^<"=])' . $link . '@', "\\1$getlink", $tweet->tw_text, 1);
		}
	}
	unset ($tweet);
	return $tweets_to_post;
}


// Just plugging in the HTML failed because TT runs it first through
// wp_specialchars and then through make_clickable. So the HTML gets
// turned into &lt;a href=&quot; and so forth.
// Let's try this (inspired by the More tag plugin by Tarique Sani)
function ktv_aktt_nicelinks_convert($post_data){
	$post_data = str_replace('[~~url=','<a href="',$post_data);
	$post_data = str_replace('~~]','">',$post_data);
	$post_data = str_replace('[/~~/]','</a>',$post_data);


	return $post_data;
}


function ktv_aktt_nicelinks_replace($url) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 5);
	
	// Retrieve content and final URL.
        $output = curl_exec($ch);
	$finalURL = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);

        curl_close($ch);
	
	
	if ($output === FALSE) {
		// We didn't get anything, so let's return a blank.
		return "";

	} else {
		// Extract title from content. Failing that, extract hostname
		$title="";
		if (preg_match("/\<title\>([^<]+)\</i", $output, $matches)) {
			$title = $matches[1];
		} else if (preg_match('@^(?:http://)?(?:www\.)?([^/]+)@i', $finalURL, $match2)) {
			$title = "(" . $match2[1] . ")";
		}
		//print "$url - $finalURL - $title\n";



		if ($title != "") {
			return '[~~url=' . $finalURL . '~~]' . $title . '[/~~/]';
		} else {
			// We didn't get a title, but we can at least return the final URL.
			// If it's the same as the original, big deal.
			return $finalURL;
		}
	}

}


add_filter('aktt_tweets_to_digest_post', 'ktv_aktt_nicelinks');
add_filter('aktt_digest_post_data', 'ktv_aktt_nicelinks_convert');

?>